%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                   %
%  Solve an Input-Output Fitting problem with a BR Neural Network   %
%                                                                   %
%            Created by Mohammad Javad Azarhoosh                    %
%                                                                   %
%             Amirkabir University of Technology                    %
%                                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc
clear
close all

%% Data Loading
n = input('Please Enter Number of Data of Each Parameter (n):\nFor Example: Number of Sonication Temperature Data (n)\n');

inputs = zeros(4,n);

fprintf('\n\n\n')

inputs(1,:) = input('Please Enter US Intensity Dataset (Between 12,27,48,75,108,147,192,243,300 W/cm2)\nExample: [27 75 243] if n=3\n');

fprintf('\n\n\n')

inputs(2,:) = input('Please Enter US Irradiation Time Dataset (Between 5 - 30 min)\nExample: [10 20 30] if n=3\n');

fprintf('\n\n\n')

inputs(3,:) = input('Please Enter Sonication Temperature Dataset (Between 20 - 50 Celcius)\nExample: [20 30 50] if n=3\n');

fprintf('\n\n\n')

inputs(4,:) = 7;  % Sonotrode tip diameter (mm) - Constant

%% Normalization
Min_inputs = [12 5 20 3];
Min_targets = [1 1.19047619047619 0.185185185185185];
Max_inputs = [460 30 50 14];
Max_targets = [1.42857142857143 2.77777777777778 2];


for i = 1:4
    inputs(i,:) = Normalize_Fcn(inputs(i,:),Min_inputs(i),Max_inputs(i));
end

% Test the Network
load ('NETWORK.mat');
outputs = net(inputs);

%% deNormalization
for i = 1:4
    inputs(i,:) = deNormalize_Fcn(inputs(i,:),Min_inputs(i),Max_inputs(i));
end
for i = 1:3
    outputs(i,:) = deNormalize_Fcn(outputs(i,:),Min_targets(i),Max_targets(i));
    outputs(i,:) = 100 ./ outputs(i,:);
end
       
disp('Methanol Conversion (%) is:')
    
disp(outputs(1,:))

fprintf('\n\n\n')
    
disp('Light Olefins Content (wt%) is:')
    
disp(outputs(2,:))

fprintf('\n\n\n')
    
disp('Life Time (min) is:')
    
disp(outputs(3,:))



